{$if not def DEVICES_HARDBLOCKS_H} CONST DEVICES_HARDBLOCKS_H=0;

{ **********************************************************************
  ** KickPascal-Include-Datei "devices/hardblocks.h" zu Kickstart 3.0 **
  ********************************************************************** }

TYPE p_RigidDiskBlock = ^RigidDiskBlock;
TYPE p_BadBlockEntry = ^BadBlockEntry;
TYPE p_BadBlockBlock = ^BadBlockBlock;
TYPE p_PartitionBlock = ^PartitionBlock;
TYPE p_FileSysHeaderBlock = ^FileSysHeaderBlock;
TYPE p_LoadSegBlock = ^LoadSegBlock;

{$if not def EXEC_IO_H;incl "exec/io.h";endif}

TYPE RigidDiskBlock = RECORD
 rdb_ID                 : Long;
 rdb_SummedLongs        : Long;
 rdb_ChkSum             : LongInt;
 rdb_HostID             : Long;
 rdb_BlockBytes         : Long;
 rdb_Flags              : Long;
 rdb_BadBlockList       : Long;
 rdb_PartitionList      : Long;
 rdb_FileSysHeaderList  : Long;
 rdb_DriveInit          : Long;
 rdb_Reserved1          : ARRAY[0..5] OF Long;
 rdb_Cylinders          : Long;
 rdb_Sectors            : Long;
 rdb_Heads              : Long;
 rdb_Interleave         : Long;
 rdb_Park               : Long;
 rdb_Reserved2          : ARRAY[0..2] Of Long;
 rdb_WritePreComp       : Long;
 rdb_ReducedWrite       : Long;
 rdb_StepRate           : Long;
 rdb_Reserved3          : ARRAY[0..4] OF Long;
 rdb_RDBBlocksLo        : Long;
 rdb_RDBBlocksHi        : Long;
 rdb_LoCylinder         : Long;
 rdb_HiCylinder         : Long;
 rdb_CylBlocks          : Long;
 rdb_AutoParkSeconds    : Long;
 rdb_Reserved4          : ARRAY[0..1] Of Long;
 rdb_DiskVendor         : String[8];
 rdb_DiskProduct        : String[16];
 rdb_DiskRevision       : String[4];
 rdb_ControllerVendor   : String[8];
 rdb_ControllerProduct  : String[16];
 rdb_ControllerRevision : String[4];
 rdb_Reserved5          : ARRAY[0..9] Of Long;
END;

CONST IDNAME_RIGIDDISK = $5244534B; { "RDSK" }

CONST RDB_LOCATION_LIMIT = 16;

CONST
 RDBFB_LAST       = 0;
 RDBFF_LAST       = $01;
 RDBFB_LASTLUN    = 1;
 RDBFF_LASTLUN    = $02;
 RDBFB_LASTTID    = 2;
 RDBFF_LASTTID    = $04;
 RDBFB_NORESELECT = 3;
 RDBFF_NORESELECT = $08;
 RDBFB_DISKID     = 4;
 RDBFF_DISKID     = $10;
 RDBFB_CTRLRID    = 5;
 RDBFF_CTRLRID    = $20;
 
 RDBFB_SYNCH      = 6;
 RDBFF_SYNCH      = $40;


TYPE BadBlockEntry = RECORD
 bbe_BadBlock  : Long;
 bbe_GoodBlock : Long;
END;

TYPE BadBlockBlock = RECORD
 bbb_ID          : Long;
 bbb_SummedLongs : Long;
 bbb_ChkSum      : LongInt;
 bbb_HostID      : Long;
 bbb_Next        : Long;
 bbb_Reserved    : Long;
 bbb_BlockPairs  : ARRAY[0..60] OF BadBlockEntry;
END;

CONST IDNAME_BADBLOCK = $42414442; { "BADB" }


TYPE PartitionBlock = RECORD
 pb_ID          : Long;
 pb_SummedLongs : Long;
 pb_ChkSum      : LongInt;
 pb_HostID      : Long;
 pb_Next        : Long;
 pb_Flags       : Long;
 pb_Reserved1   : ARRAY[0..1] Of Long;
 pb_DevFlags    : Long;
 pb_DriveName   : ARRAY[0..31] OF Char;
 pb_Reserved2   : ARRAY[0..14] OF Long;
 pb_Environment : ARRAY[0..16] Of Long;
 pb_EReserved   : ARRAY[0..14] Of Long;
END;

CONST IDNAME_PARTITION = $50415254; { "PART" }

CONST
 PBFB_BOOTABLE = 0;
 PBFF_BOOTABLE = 1;
 PBFB_NOMOUNT  = 1;
 PBFF_NOMOUNT  = 2;


TYPE FileSysHeaderBlock = RECORD
 fhb_ID            : Long;
 fhb_SummedLongs   : Long;
 fhb_ChkSum        : LongInt;
 fhb_HostID        : Long;
 fhb_Next          : Long;
 fhb_Flags         : Long;
 fhb_Reserved1     : ARRAY[0..1] OF Long;
 fhb_DosType       : Long;
 fhb_Version       : Long;
 fhb_PatchFlags    : Long;
 fhb_Type          : Long;
 fhb_Task          : Long;
 fhb_Lock          : Long;
 fhb_Handler       : Long;
 fhb_StackSize     : Long;
 fhb_Priority      : LongInt;
 fhb_Startup       : LongInt;
 fhb_SegListBlocks : LongInt;
 fhb_GlobalVec     : LongInt;
 fhb_Reserved2     : ARRAY[0..22] OF Long;
 fhb_Reserved3     : ARRAY[0..20] OF Long;
END;

CONST IDNAME_FILESYSHEADER = $46534844; { "FSHD" }


TYPE LoadSegBlock = RECORD
 lsb_ID          : Long;
 lsb_SummedLongs : Long;
 lsb_ChkSum      : LongInt;
 lsb_HostID      : Long;
 lsb_Next        : Long;
 lsb_LoadData    : ARRAY[0..122] Of Long;
END;

CONST IDNAME_LOADSEG = $4C534547; { "LSEG" }

{$endif}
