{$if not def DEVICES_NARRATOR_H} CONST DEVICES_NARRATOR_H=0;

{ ********************************************************************
  ** KickPascal-Include-Datei "devices/narrator.h" zu Kickstart 3.0 **
  ******************************************************************** }

{ *** nicht mehr Bestandteil des Betriebssystems! *** }

TYPE p_narrator_rb = ^narrator_rb;
TYPE p_mouth_rb = ^mouth_rb;

{$if not def EXEC_IO_H;incl "exec/io.h";endif}

CONST
 NDB_NEWIORB  = 0;
 NDB_WORDSYNC = 1;
 NDB_SYLSYNC  = 2;

CONST
 NDF_NEWIORB  = $1;
 NDF_WORDSYNC = $2;
 NDF_SYLSYNC  = $4;


CONST
 ND_NoMem       = -2;
 ND_NoAudLib    = -3;
 ND_MakeBad     = -4;
 ND_UnitErr     = -5;
 ND_CantAlloc   = -6;
 ND_Unimpl      = -7;
 ND_NoWrite     = -8;
 ND_Expunged    = -9;
 ND_PhonErr     = -20;
 ND_RateErr     = -21;
 ND_PitchErr    = -22;
 ND_SexErr      = -23;
 ND_ModeErr     = -24;
 ND_FreqErr     = -25;
 ND_VolErr      = -26;
 ND_DCentErr    = -27;
 ND_CentPhonErr = -28;


CONST
 DEFPITCH     = 110;
 DEFRATE      = 150;
 DEFVOL       = 64;
 DEFFREQ      = 22200;
 MALE         = 0;
 FEMALE       = 1;
 NATURALF0    = 0;
 ROBOTICF0    = 1;
 MANUALF0     = 2;
 DEFSEX       = MALE;
 DEFMODE      = NATURALF0;
 DEFARTIC     = 100;
 DEFCENTRAL   = 0;
 DEFF0PERT    = 0;
 DEFF0ENTHUS  = 32;
 DEFPRIORITY  = 100;

CONST
 MINRATE    = 40;
 MAXRATE    = 400;
 MINPITCH   = 65;
 MAXPITCH   = 320;
 MINFREQ    = 5000;
 MAXFREQ    = 28000;
 MINVOL     = 0;
 MAXVOL     = 64;
 MINCENT    = 0;
 MAXCENT    = 100;

TYPE narrator_rb = RECORD
 message      : IOStdReq;
 rate         : Word;
 pitch        : Word;
 mode         : Word;
 sex          : Word;
 ch_masks     : Ptr;
 nm_masks     : Word;
 volume       : Word;
 sampfreq     : Word;
 mouths       : Byte;
 chanmask     : Byte;
 numchan      : Byte;
 flags        : Byte;
 F0enthusiasm : Byte;
 F0perturb    : Byte;
 F1adj        : Short;
 F2adj        : Short;
 F3adj        : Short;
 A1adj        : Short;
 A2adj        : Short;
 A3adj        : Short;
 articulate   : Byte;
 centralize   : Byte;
 centphon     : Str;
 AVbias       : Short;
 AFbias       : Short;
 priority     : Short;
 pad1         : Short;
END;

TYPE mouth_rb = RECORD
 voice  : narrator_rb;
 width  : Byte;
 height : Byte;
 shape  : Byte;
 sync   : Byte;
END;

{$endif}

