{$if not def DEVICES_PRINTER_H} CONST DEVICES_PRINTER_H=0;

{ *******************************************************************
  ** KickPascal-Include-Datei "devices/printer.h" zu Kickstart 3.0 **
  ******************************************************************* }

TYPE p_IODRPReq = ^IODRPReq;
TYPE p_IOPrtCmdReq = ^IOPrtCmdReq;


{$if not def EXEC_NODES_H;incl "exec/nodes.h";endif}
{$if not def EXEC_LISTS_H;incl "exec/lists.h";endif}
{$if not def EXEC_IO_H;incl "exec/io.h";endif}
{$if not def EXEC_PORTS_H;incl "exec/ports.h";endif}
{$if not def GRAPHICS_RASTPORT_H;incl "graphics/rastport.h";endif}
{$if not def GRAPHICS_VIEW_H;incl "graphics/view.h";endif}


CONST
  PRD_RAWWRITE   = (CMD_NONSTD+0);
  PRD_PRTCOMMAND = (CMD_NONSTD+1);
  PRD_DUMPRPORT  = (CMD_NONSTD+2);
  PRD_QUERY      = (CMD_NONSTD+3);

CONST
 aRIS    = 0;
 aRIN    = 1;
 aIND    = 2;
 aNEL    = 3;
 aRI     = 4;
 aSGR0   = 5;
 aSGR3   = 6;
 aSGR23  = 7;
 aSGR4   = 8;
 aSGR24  = 9;
 aSGR1   = 10;
 aSGR22  = 11;
 aSFC    = 12;
 aSBC    = 13;
 aSHORP0 = 14;
 aSHORP2 = 15;
 aSHORP1 = 16;
 aSHORP4 = 17;
 aSHORP3 = 18;
 aSHORP6 = 19;
 aSHORP5 = 20;
 aDEN6   = 21;
 aDEN5   = 22;
 aDEN4   = 23;
 aDEN3   = 24;
 aDEN2   = 25;
 aDEN1   = 26;
 aSUS2   = 27;
 aSUS1   = 28;
 aSUS4   = 29;
 aSUS3   = 30;
 aSUS0   = 31;
 aPLU    = 32;
 aPLD    = 33;
 aFNT0   = 34;
 aFNT1   = 35;
 aFNT2   = 36;
 aFNT3   = 37;
 aFNT4   = 38;
 aFNT5   = 39;
 aFNT6   = 40;
 aFNT7   = 41;
 aFNT8   = 42;
 aFNT9   = 43;
 aFNT10  = 44;
 aPROP2  = 45;
 aPROP1  = 46;
 aPROP0  = 47;
 aTSS    = 48;
 aJFY5   = 49;
 aJFY7   = 50;
 aJFY6   = 51;
 aJFY0   = 52;
 aJFY3   = 53;
 aJFY1   = 54;
 aVERP0  = 55;
 aVERP1  = 56;
 aSLPP   = 57;
 aPERF   = 58;
 aPERF0  = 59;
 aLMS    = 60;
 aRMS    = 61;
 aTMS    = 62;
 aBMS    = 63;
 aSTBM   = 64;
 aSLRM   = 65;
 aCAM    = 66;
 aHTS    = 67;
 aVTS    = 68;
 aTBC0   = 69;
 aTBC3   = 70;
 aTBC1   = 71;
 aTBC4   = 72;
 aTBCALL = 73;
 aTBSALL = 74;
 aEXTEND = 75;
 aRAW    = 76;

TYPE IOPrtCmdReq = RECORD
 io_Message    : Message;
 io_Device     : p_Device;
 io_Unit       : p_Unit;
 io_Command    : Word;
 io_Flags      : Byte;
 io_Error      : Short;
 io_PrtCommand : Word;
 io_Parm0      : Byte;
 io_Parm1      : Byte;
 io_Parm2      : Byte;
 io_Parm3      : Byte;
END;

TYPE IODRPReq = RECORD
 io_Message   : Message;
 io_Device    : p_Device;
 io_Unit      : p_Unit;
 io_Command   : Word;
 io_Flags     : Byte;
 io_Error     : Short;
 io_RastPort  : p_RastPort;
 io_ColorMap  : p_ColorMap;
 io_Modes     : Long;
 io_SrcX      : Word;
 io_SrcY      : Word;
 io_SrcWidth  : Word;
 io_SrcHeight : Word;
 io_DestCols  : LongInt;
 io_DestRows  : LongInt;
 io_Special   : Word;
END;

CONST
 SPECIAL_MILCOLS  = $0001;
 SPECIAL_MILROWS  = $0002;
 SPECIAL_FULLCOLS = $0004;
 SPECIAL_FULLROWS = $0008;
 SPECIAL_FRACCOLS = $0010;
 SPECIAL_FRACROWS = $0020;
 SPECIAL_CENTER   = $0040;
 SPECIAL_ASPECT   = $0080;
 SPECIAL_DENSITY1 = $0100;
 SPECIAL_DENSITY2 = $0200;
 SPECIAL_DENSITY3 = $0300;
 SPECIAL_DENSITY4 = $0400;
 SPECIAL_DENSITY5 = $0500;
 SPECIAL_DENSITY6 = $0600;
 SPECIAL_DENSITY7 = $0700;
 SPECIAL_NOFORMFEED = $0800;
 SPECIAL_TRUSTME  = $1000;
 SPECIAL_NOPRINT  = $2000;

CONST
 PDERR_NOERR           = 0;
 PDERR_CANCEL          = 1;
 PDERR_NOTGRAPHICS     = 2;
 PDERR_INVERTHAM       = 3;
 PDERR_BADDIMENSION    = 4;
 PDERR_DIMENSIONOVFLOW = 5;
 PDERR_INTERNALMEMORY  = 6;
 PDERR_BUFFERMEMORY    = 7;
 PDERR_TOOKCONTROL     = 8;

CONST
 SPECIAL_DENSITYMASK = $0700;
 SPECIAL_DIMENSIONSMASK = (SPECIAL_MILCOLS or SPECIAL_MILROWS or SPECIAL_FULLCOLS or SPECIAL_FULLROWS or SPECIAL_FRACCOLS or SPECIAL_FRACROWS or SPECIAL_ASPECT);
{$endif}
