{$if not def DEVICES_PRTBASE_H} CONST DEVICES_PRTBASE_H=0;

{ *******************************************************************
  ** KickPascal-Include-Datei "devices/prtbase.h" zu Kickstart 3.0 **
  ******************************************************************* }

TYPE p_DeviceData = ^DeviceData;
TYPE p_PrinterSegment = ^PrinterSegment;
TYPE p_PrinterData = ^PrinterData;
TYPE p_PrinterExtendedData = ^PrinterExtendedData;

{$if not def EXEC_NODES_H;incl "exec/nodes.h";endif}
{$if not def EXEC_LISTS_H;incl "exec/lists.h";endif}
{$if not def EXEC_PORTS_H;incl "exec/ports.h";endif}
{$if not def EXEC_LIBRARIES_H;incl "exec/libraries.h";endif}
{$if not def EXEC_TASKS_H;incl "exec/tasks.h";endif}
{$if not def DEVICES_PARALLEL_H;incl "devices/parallel.h";endif}
{$if not def DEVICES_SERIAL_H;incl "devices/serial.h";endif}
{$if not def DEVICES_TIMER_H;incl "devices/timer.h";endif}
{$if not def LIBRARIES_DOSEXTENS_H;incl "libraries/dosextens.h";endif}
{$if not def INTUITION_INTUITION_H;incl "intuition/intuition.h";endif}


TYPE DeviceData = RECORD
 dd_Device      : _Library;
 dd_Segment     : Ptr;
 dd_ExecBase    : Ptr;
 dd_CmdVectors  : Ptr;
 dd_CmdBytes    : Ptr;
 dd_NumCommands : Word;
END;

CONST
 P_OLDSTKSIZE = $0800;
 P_STKSIZE    = $1000;
 P_BUFSIZE    = 256;
 P_SAFESIZE   = 128;


TYPE PrinterData = RECORD
 pd_Device         : DeviceData;
 pd_Unit           : MsgPort;
 pd_PrinterSegment : BPTR;
 pd_PrinterType    : Word;
 pd_SegmentData    : p_PrinterSegment;
 pd_PrintBuf       : Ptr;
 pd_PWrite         : Ptr;
 pd_PBothReady     : Ptr;
 pd_ior0           : RECORD
                     CASE Integer OF
                     0 : (pd_p0 : IoExtPar);
                     1 : (pd_s0 : IoExtSer);
                     END;
 pd_ior1           : RECORD
                     CASE Integer OF
                     0 : (pd_p1 : IoExtPar);
                     1 : (pd_s1 : IoExtSer);
                     END;
 pd_TIOR           : timerequest;
 pd_IORPort        : MsgPort;
 pd_TC             : Task ;
 pd_OldStk         : ARRAY[0..P_OLDSTKSIZE-1] OF Byte;
 pd_Flags          : Byte;
 pd_pad            : Byte;
 pd_Preferences    : Preferences;
 pd_PWaitEnabled   : Byte;
 pd_Flags1         : Byte;
 pd_Stk            : ARRAY[0..P_STKSIZE-1] OF Byte;
END;

CONST
 PPCB_GFX    = 0;
 PPCF_GFX    = $1;
 PPCB_COLOR  = 1;
 PPCF_COLOR  = $2;

CONST
 PPC_BWALPHA    = $00;
 PPC_BWGFX      = $01;
 PPC_COLORALPHA = $02;
 PPC_COLORGFX   = $03;

CONST
 PCC_BW         = $01;
 PCC_YMC        = $02;
 PCC_YMC_BW     = $03;
 PCC_YMCB       = $04;
 PCC_4COLOR     = $04;
 PCC_ADDITIVE   = $08;
 PCC_WB         = $09;
 PCC_BGR        = $0A;
 PCC_BGR_WB     = $0B;
 PCC_BGRW       = $0C;
 PCC_MULTI_PASS = $10;


TYPE PrinterExtendedData = RECORD
 ped_PrinterName  : Str;
 ped_Init         : Ptr;
 ped_Expunge      : Ptr;
 ped_Open         : Ptr;
 ped_Close        : Ptr;
 ped_PrinterClass : Byte;
 ped_ColorClass   : Byte;
 ped_MaxColumns   : Byte;
 ped_NumCharSets  : Byte;
 ped_NumRows      : Word;
 ped_MaxXDots     : Long;
 ped_MaxYDots     : Long;
 ped_XDotsInch    : Word;
 ped_YDotsInch    : Word;
 ped_Commands     : Ptr;
 ped_DoSpecial    : Ptr;
 ped_Render       : Ptr;
 ped_TimeoutSecs  : Long;
 ped_8BitChars    : Ptr;
 ped_PrintMode    : LongInt;
 ped_ConvFunc     : LongInt;
END;

TYPE PrinterSegment = RECORD
 ps_NextSegment : Long;
 ps_runAlert    : Long;
 ps_Version     : Word;
 ps_Revision    : Word;
 ps_PED         : PrinterExtendedData;
END;
{$endif}
