{$if not def DEVICES_SERIAL_H} CONST DEVICES_SERIAL_H=0;

{ ******************************************************************
  ** KickPascal-Include-Datei "devices/serial.h" zu Kickstart 3.0 **
  ****************************************************************** }

TYPE p_IOTArray = ^IOTArray;
TYPE p_IOExtSer = ^IOExtSer;

{$if not def EXEC_IO_H;incl "exec/io.h";endif}

TYPE IOTArray = RECORD
 TermArray0 : Long;
 TermArray1 : Long;
END;

CONST SER_DEFAULT_CTLCHAR = $11130000;

TYPE IOExtSer = RECORD
 IOSer        : IOStdReq;
 io_CtlChar   : Long;
 io_RBufLen   : Long;
 io_ExtFlags  : Long;
 io_Baud      : Long;
 io_BrkTime   : Long;
 io_TermArray : IOTArray;
 io_ReadLen   : Byte;
 io_WriteLen  : Byte;
 io_StopBits  : Byte;
 io_SerFlags  : Byte;
 io_Status    : Word;
END;

CONST
 SDCMD_QUERY     = CMD_NONSTD;
 SDCMD_BREAK     = (CMD_NONSTD+1);
 SDCMD_SETPARAMS = (CMD_NONSTD+2);


CONST
 SERB_XDISABLED  = 7;
 SERF_XDISABLED  = $80;
 SERB_EOFMODE    = 6;
 SERF_EOFMODE    = $40;
 SERB_SHARED     = 5;
 SERF_SHARED     = $20;
 SERB_RAD_BOOGIE = 4;
 SERF_RAD_BOOGIE = $10;
 SERB_QUEUEDBRK  = 3;
 SERF_QUEUEDBRK  = $8;
 SERB_7WIRE      = 2;
 SERF_7WIRE      = $4;
 SERB_PARTY_ODD  = 1;
 SERF_PARTY_ODD  = $2;
 SERB_PARTY_ON   = 0;
 SERF_PARTY_ON   = $1;

CONST
 IO_STATB_XOFFREAD   = 12;
 IO_STATF_XOFFREAD   = $1000;
 IO_STATB_XOFFWRITE  = 11;
 IO_STATF_XOFFWRITE  = $800;
 IO_STATB_READBREAK  = 10;
 IO_STATF_READBREAK  = $400;
 IO_STATB_WROTEBREAK = 9;
 IO_STATF_WROTEBREAK = $200;
 IO_STATB_OVERRUN    = 8;
 IO_STATF_OVERRUN    = $100;

CONST
 SEXTB_MSPON = 1;
 SEXTF_MSPON = $2;
 SEXTB_MARK  = 0;
 SEXTF_MARK  = $1;

CONST
 SerErr_DevBusy       = 1;
 SerErr_BaudMismatch  = 2;
 SerErr_BufErr        = 4;
 SerErr_InvParam      = 5;
 SerErr_LineErr       = 6;
 SerErr_ParityErr     = 9;
 SerErr_TimerErr      = 11;
 SerErr_BufOverflow   = 12;
 SerErr_NoDSR         = 13;
 SerErr_DetectedBreak = 15;


{$if def DEVICES_SERIAL_H_OBSOLETE}
CONST
 SerErr_InvBaud   = 3;
 SerErr_NotOpen   = 7;
 SerErr_PortReset = 8;
 SerErr_InitErr   = 10;
 SerErr_NoCTS     = 14;
 IOSTB_XOFFREAD   = 4;
 IOSTF_XOFFREAD   = $10;
 IOSTB_XOFFWRITE  = 3;
 IOSTF_XOFFWRITE  = $8;
 IOSTB_READBREAK  = 2;
 IOSTF_READBREAK  = $4;
 IOSTB_WROTEBREAK = 1;
 IOSTF_WROTEBREAK = $2;
 IOSTB_OVERRUN    = 0;
 IOSTF_OVERRUN    = $1;

 IOSERB_BUFRREAD  = 7;
 IOSERF_BUFRREAD  = $80;
 IOSERB_QUEUED    = 6;
 IOSERF_QUEUED    = $40;
 IOSERB_ABORT     = 5;
 IOSERF_ABORT     = $20;
 IOSERB_ACTIVE    = 4;
 IOSERF_ACTIVE    = $10;
{$endif}


CONST SERIALNAME = "serial.device";

{$endif}
