{$if not def DEVICES_TIMER_H} CONST DEVICES_TIMER_H=0;

{ *****************************************************************
  ** KickPascal-Include-Datei "devices/timer.h" zu Kickstart 3.0 **
  ***************************************************************** }

TYPE p_timeval = ^timeval;
TYPE p_EClockVal = ^EClockVal;
TYPE p_timerequest = ^timerequest;

{$if not def EXEC_IO_H;incl "exec/io.h";endif}

CONST
 UNIT_MICROHZ    = 0;
 UNIT_VBLANK     = 1;
 UNIT_ECLOCK     = 2;
 UNIT_WAITUNTIL  = 3;
 UNIT_WAITECLOCK = 4;

CONST TIMERNAME = "timer.device";

TYPE timeval = RECORD
 tv_secs  : Long;
 tv_micro : Long;
END;

TYPE EClockVal = RECORD
 ev_hi : Long;
 ev_lo : Long;
END;

TYPE timerequest = RECORD
 tr_node : IORequest;
 tr_time : timeval;
END;

CONST
 TR_ADDREQUEST = CMD_NONSTD;
 TR_GETSYSTIME = (CMD_NONSTD+1);
 TR_SETSYSTIME = (CMD_NONSTD+2);

{$endif}


{$if not def TIMER_LIB_H} CONST TIMER_LIB_H=0;

VAR TimerBase : Ptr;

LIBRARY TimerBase :

-42 : PROCEDURE AddTime(A0,A1:p_Timeval);
-48 : PROCEDURE SubTime(A0,A1:p_Timeval);
-54 : FUNCTION CmpTime(A0,A1:p_Timeval): LongInt;
{ **** Routinen ab V36 / Kickstart Release 2.0  **** }
-60 : FUNCTION ReadEClock(A0:p_EClockVal): Long;
-66 : PROCEDURE GetSysTime(a0: p_Timeval);
END;

{$endif}
